Experience source file for analysing the AST of Python programs using AST traversal.

## Installation
The Python AST module should be include in Python. Use Python 3.7+.

## Quick start
Create a new Python file called `flaw_1.py`. Inside you should import the `ast` module and write your visitor.
The file should look like this:
```python
import ast

class VisitorFlaw1(ast.ast.NodeVisitor):
    ...
```

After creating a visitor, add it to the list of visitor in the file [detect_flaws.py](detect_flaws.py).
To run the code, use `python detect_flaws.py`. All the result should be in the file `result.csv`.

## Structure
### File structure
Keep the structure simple.

```
code/
flaw_1.py
...
flaw_n.py
detect_flaws.py
readme.md
result.csv
```

### CSV structure
Please keep the structure of the output csv file.
```
code;flaw_1;flaw_2;...;flaw_n
code1;True;False;...;False
...
coden;False;True;...False
```

### [detect_flaws.py](detect_flaws.py) structure
You can change this file as you want. But as said before, please keep the same output format in the csv.
The instruction `visitor.found` at line 42 is an example of possible output for the visitors. You can change it if you want.

## Result
At the end, please provide all the content of this folder. Even unfinished code will be useful! All the code is anonymous.